# Data structures

Data structures define the format of the data being transferred to the Make platform. For example, they are widely used by the Data stores component. The following endpoints allow you to create and manage data structures.

## List data structures

> Retrieves a collection of all data structures for a team with a given ID. Returned data structures are sorted by name in ascending order.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Data structures","description":"Data structures define the format of the data being transferred to the Make platform. For example, they are widely used by the Data stores component. The following endpoints allow you to create and manage data structures."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["udts:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/data-structures":{"get":{"tags":["Data structures"],"summary":"List data structures","description":"Retrieves a collection of all data structures for a team with a given ID. Returned data structures are sorted by name in ascending order.","parameters":[{"name":"teamId","in":"query","schema":{"type":"integer"},"required":true,"description":"The unique ID of the team whose data structures will be retrieved."},{"name":"cols[]","in":"query","schema":{"type":"array","items":{"type":"string","enum":["id","name","teamId","spec","strict"]}},"description":"Specifies the group of values to return. For example, you can retrieve only names of data structures for a team with a given ID."},{"name":"pg[sortBy]","in":"query","schema":{"type":"string","enum":["name"]},"description":"The value that will be used to sort returned entities by."},{"name":"pg[offset]","in":"query","schema":{"type":"integer"},"description":"The value of entities you want to skip before getting entities you need."},{"name":"pg[sortDir]","in":"query","schema":{"type":"string","enum":["asc","desc"]},"description":"The sorting order. It accepts the ascending and descending direction specifiers."},{"name":"pg[limit]","in":"query","schema":{"type":"integer"},"description":"Sets the maximum number of results per page in the API call response. For example, `pg[limit]=100`. The default number varies with different API endpoints."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"dataStructures":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer"},"teamId":{"type":"integer"},"name":{"type":"string","minLength":1,"maxLength":128},"strict":{"type":"boolean"},"spec":{"type":"array","items":{"oneOf":[{"type":"object","properties":{"type":{"type":"string","enum":["boolean"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["text"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"string"},"multiline":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["number"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"number"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["date"]},"name":{"type":"string"},"label":{"type":"string"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["buffer"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"codepage":{"type":"string","enum":["binary","utf8"]}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["collection"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"array","items":{"type":"object"}},"sequence":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["array"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"object"},"sequence":{"type":"boolean"}},"required":["name","type"]}]}}},"required":["id","teamId","name","strict","spec"]}},"pg":{"type":"object","properties":{"last":{"type":"string"},"showLast":{"type":"boolean"},"sortBy":{"type":"string"},"sortDir":{"type":"string"},"limit":{"type":"integer"},"offset":{"type":"integer"}}}}}}}}}}}}}
```

## Create data structure

> Creates a new data structure with data passed in the request body. In the response, it returns all details of the created data structure including its full specification.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Data structures","description":"Data structures define the format of the data being transferred to the Make platform. For example, they are widely used by the Data stores component. The following endpoints allow you to create and manage data structures."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["udts:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/data-structures":{"post":{"tags":["Data structures"],"summary":"Create data structure","description":"Creates a new data structure with data passed in the request body. In the response, it returns all details of the created data structure including its full specification.","requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"teamId":{"type":"integer","description":"The unique ID of the team in which the data structure will be created."},"name":{"type":"string","description":"The name of the data structure. The maximum length of the name is 128 characters.","minLength":1,"maxLength":128},"strict":{"type":"boolean","description":"Set to `true` to enforce strict validation of the data put in the data structure. With the strict validation enabled, the data structure won't store data that don't fit into the structure and the storing module will return an error.\n\nThe default value of this parameter is `false`. With the default setting, the modules using the data structure will process data that don't conform to the data structure.\n"},"spec":{"type":"array","description":"Sets the data structure specification.","items":{"oneOf":[{"type":"object","properties":{"type":{"type":"string","enum":["boolean"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["text"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"string"},"multiline":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["number"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"number"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["date"]},"name":{"type":"string"},"label":{"type":"string"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["buffer"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"codepage":{"type":"string","enum":["binary","utf8"]}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["collection"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"array","items":{"type":"object"}},"sequence":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["array"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"object"},"sequence":{"type":"boolean"}},"required":["name","type"]}]}}},"required":["teamId","name","strict","spec"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"dataStructure":{"type":"object","properties":{"id":{"type":"integer"},"teamId":{"type":"integer"},"name":{"type":"string","minLength":1,"maxLength":128},"strict":{"type":"boolean"},"spec":{"type":"array","items":{"oneOf":[{"type":"object","properties":{"type":{"type":"string","enum":["boolean"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["text"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"string"},"multiline":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["number"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"number"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["date"]},"name":{"type":"string"},"label":{"type":"string"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["buffer"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"codepage":{"type":"string","enum":["binary","utf8"]}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["collection"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"array","items":{"type":"object"}},"sequence":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["array"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"object"},"sequence":{"type":"boolean"}},"required":["name","type"]}]}}},"required":["id","teamId","name","strict","spec"]}}}}}}}}}}}
```

## Get data structure

> Retrieves a data structure with a given ID

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Data structures","description":"Data structures define the format of the data being transferred to the Make platform. For example, they are widely used by the Data stores component. The following endpoints allow you to create and manage data structures."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["udts:read"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/data-structures/{dataStructureId}":{"get":{"tags":["Data structures"],"summary":"Get data structure","description":"Retrieves a data structure with a given ID","parameters":[{"name":"dataStructureId","in":"path","schema":{"type":"integer"},"required":true,"description":"The data structure ID. Get the `dataStructureId` with the [list data structures](/api-reference/data-structures/get--data-structures.md) endpoint."},{"name":"cols[]","in":"query","schema":{"type":"array","items":{"type":"string","enum":["id","name","teamId","spec","strict"]}},"description":"Specifies the group of values to return. For example, you can retrieve only name of a data structure."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"dataStructure":{"type":"object","properties":{"id":{"type":"integer"},"teamId":{"type":"integer"},"name":{"type":"string","minLength":1,"maxLength":128},"strict":{"type":"boolean"},"spec":{"type":"array","items":{"oneOf":[{"type":"object","properties":{"type":{"type":"string","enum":["boolean"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["text"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"string"},"multiline":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["number"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"number"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["date"]},"name":{"type":"string"},"label":{"type":"string"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["buffer"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"codepage":{"type":"string","enum":["binary","utf8"]}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["collection"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"array","items":{"type":"object"}},"sequence":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["array"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"object"},"sequence":{"type":"boolean"}},"required":["name","type"]}]}}},"required":["id","teamId","name","strict","spec"]}}}}}}}}}}}
```

## Delete data structure

> Deletes a data structure with a given ID and returns the ID in the response.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Data structures","description":"Data structures define the format of the data being transferred to the Make platform. For example, they are widely used by the Data stores component. The following endpoints allow you to create and manage data structures."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["udts:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/data-structures/{dataStructureId}":{"delete":{"tags":["Data structures"],"summary":"Delete data structure","description":"Deletes a data structure with a given ID and returns the ID in the response.","parameters":[{"name":"dataStructureId","in":"path","schema":{"type":"integer"},"required":true,"description":"The data structure ID. Get the `dataStructureId` with the [list data structures](/api-reference/data-structures/get--data-structures.md) endpoint."},{"name":"confirmed","in":"query","schema":{"type":"boolean"},"description":"Confirms the deletion if a data structure is included in at least one scenario. Confirmation is required because the scenario will stop working without the data structure. If the parameter is missing or it is set to `false` an error code is returned and the resource is not deleted."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"dataStructure":{"type":"integer"}}}}}}}}}}}
```

## Update data structure

> Updates the specified data structure. Make updates only parameters you send in the request body.\
> Note that when you update the data structure specification with the \`spec\` parameter, you have to provide all structure fields you want to use. Make replaces the old structure specification with the new one.\
> The response contains all details about the updated data structure.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Data structures","description":"Data structures define the format of the data being transferred to the Make platform. For example, they are widely used by the Data stores component. The following endpoints allow you to create and manage data structures."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["udts:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/data-structures/{dataStructureId}":{"patch":{"tags":["Data structures"],"summary":"Update data structure","description":"Updates the specified data structure. Make updates only parameters you send in the request body.\nNote that when you update the data structure specification with the `spec` parameter, you have to provide all structure fields you want to use. Make replaces the old structure specification with the new one.\nThe response contains all details about the updated data structure.","requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"type":"string","description":"The name of the data structure. The maximum length of the name is 128 characters.","minLength":1,"maxLength":128},"strict":{"type":"boolean","description":"Set to `true` to enforce strict validation of the data put in the data structure. With the strict validation enabled, the data structure won't store data that don't fit into the structure and the storing module will return an error.\n\nThe default value of this parameter is `false`. With the default setting, the modules using the data structure will process data that don't conform to the data structure.\n"},"spec":{"type":"array","description":"Sets the data structure specification.\n \nNote that when you update the data structure specification with the `spec` parameter, you have to provide all structure fields you want to use. Make replaces the old structure specification with the new one.\"\n","items":{"oneOf":[{"type":"object","properties":{"type":{"type":"string","enum":["boolean"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["text"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"string"},"multiline":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["number"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"number"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["date"]},"name":{"type":"string"},"label":{"type":"string"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["buffer"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"codepage":{"type":"string","enum":["binary","utf8"]}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["collection"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"array","items":{"type":"object"}},"sequence":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["array"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"object"},"sequence":{"type":"boolean"}},"required":["name","type"]}]}}}}}}},"parameters":[{"name":"dataStructureId","in":"path","schema":{"type":"integer"},"required":true,"description":"The data structure ID. Get the `dataStructureId` with the [list data structures](/api-reference/data-structures/get--data-structures.md) endpoint."}],"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"dataStructure":{"type":"object","properties":{"id":{"type":"integer"},"teamId":{"type":"integer"},"name":{"type":"string","minLength":1,"maxLength":128},"strict":{"type":"boolean"},"spec":{"type":"array","items":{"oneOf":[{"type":"object","properties":{"type":{"type":"string","enum":["boolean"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["text"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"string"},"multiline":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["number"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"number"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["date"]},"name":{"type":"string"},"label":{"type":"string"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["buffer"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"codepage":{"type":"string","enum":["binary","utf8"]}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["collection"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"array","items":{"type":"object"}},"sequence":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["array"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"object"},"sequence":{"type":"boolean"}},"required":["name","type"]}]}}},"required":["id","teamId","name","strict","spec"]}}}}}}}}}}}
```

## Clone data structure

> Clones the specified data structure. Use the \`targetTeamId\` to clone the data structure to the specified team.\
> \
> The response contains all details of the data structure clone with data structure full specification.

```json
{"openapi":"3.0.0","info":{"title":"Web API v2 - Public ","version":"1.0.0"},"tags":[{"name":"Data structures","description":"Data structures define the format of the data being transferred to the Make platform. For example, they are widely used by the Data stores component. The following endpoints allow you to create and manage data structures."}],"servers":[{"url":"https://eu1.make.com/api/v2","description":"EU1 production zone"},{"url":"https://eu2.make.com/api/v2","description":"EU2 production zone"},{"url":"https://us1.make.com/api/v2","description":"US1 production zone"},{"url":"https://us2.make.com/api/v2","description":"US2 production zone"},{"url":"https://eu1.make.celonis.com/api/v2","description":"Celonis EU1 production zone"},{"url":"https://us1.make.celonis.com/api/v2","description":"Celonis US1 production zone"}],"security":[{"token":["udts:write"]}],"components":{"securitySchemes":{"token":{"type":"apiKey","name":"Authorization","in":"header","description":"Authorize the API call with your API token in the `Authorization` header with the value: `Token your-api-token`.\n\nIf you don't have an API token yet, please refer to the [\"Authentication\" section](/api-documentation/authentication) to learn how to create one.\n"}}},"paths":{"/data-structures/{dataStructureId}/clone":{"post":{"tags":["Data structures"],"summary":"Clone data structure","description":"Clones the specified data structure. Use the `targetTeamId` to clone the data structure to the specified team.\n\nThe response contains all details of the data structure clone with data structure full specification.","parameters":[{"name":"dataStructureId","in":"path","schema":{"type":"integer"},"required":true,"description":"The data structure ID. Get the `dataStructureId` with the [list data structures](/api-reference/data-structures/get--data-structures.md) endpoint."}],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"name":{"type":"string","description":"The name of the data structure clone. The maximum length of the name is 128 characters.","minLength":1,"maxLength":128},"targetTeamId":{"type":"integer","description":"The ID of the team that should use the data structure clone. If you don't specify the `targetTeamId` Make clones the data structure in the original team."}},"required":["name"]}}}},"responses":{"200":{"description":"Successful response","content":{"application/json":{"schema":{"type":"object","properties":{"dataStructure":{"type":"object","properties":{"id":{"type":"integer"},"teamId":{"type":"integer"},"name":{"type":"string","minLength":1,"maxLength":128},"strict":{"type":"boolean"},"spec":{"type":"array","items":{"oneOf":[{"type":"object","properties":{"type":{"type":"string","enum":["boolean"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["text"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"string"},"multiline":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["number"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"default":{"type":"number"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["date"]},"name":{"type":"string"},"label":{"type":"string"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["buffer"]},"name":{"type":"string"},"label":{"type":"string"},"required":{"type":"boolean"},"codepage":{"type":"string","enum":["binary","utf8"]}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["collection"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"array","items":{"type":"object"}},"sequence":{"type":"boolean"}},"required":["name","type"]},{"type":"object","properties":{"type":{"type":"string","enum":["array"]},"name":{"type":"string"},"label":{"type":"string"},"spec":{"type":"object"},"sequence":{"type":"boolean"}},"required":["name","type"]}]}}},"required":["id","teamId","name","strict","spec"]},"differentTeam":{"type":"boolean"}}}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.make.com/api-documentation/api-reference/data-structures.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
